VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "New Image Fading Example"
   ClientHeight    =   3090
   ClientLeft      =   1770
   ClientTop       =   1680
   ClientWidth     =   9615
   LinkTopic       =   "Form1"
   ScaleHeight     =   3090
   ScaleWidth      =   9615
   Begin VB.PictureBox endpic 
      AutoSize        =   -1  'True
      Height          =   2010
      Left            =   7320
      Picture         =   "Form1.frx":0000
      ScaleHeight     =   1950
      ScaleWidth      =   1995
      TabIndex        =   5
      Top             =   360
      Width           =   2055
   End
   Begin VB.PictureBox HoldNewPic 
      Height          =   495
      Left            =   4200
      ScaleHeight     =   435
      ScaleWidth      =   1155
      TabIndex        =   4
      Top             =   3540
      Width           =   1215
   End
   Begin VB.PictureBox PictureHolder 
      Height          =   1995
      Left            =   3780
      ScaleHeight     =   1935
      ScaleWidth      =   1995
      TabIndex        =   2
      Top             =   360
      Width           =   2055
   End
   Begin VB.Frame Frame1 
      BeginProperty Font 
         Name            =   "Arial"
         Size            =   8.25
         Charset         =   0
         Weight          =   400
         Underline       =   0   'False
         Italic          =   0   'False
         Strikethrough   =   0   'False
      EndProperty
      Height          =   2955
      Left            =   60
      TabIndex        =   0
      Top             =   60
      Width           =   9495
      Begin VB.HScrollBar hsrcFadeValue 
         Height          =   255
         LargeChange     =   10
         Left            =   180
         Max             =   100
         SmallChange     =   5
         TabIndex        =   3
         Top             =   2520
         Width           =   9135
      End
      Begin VB.PictureBox startpic 
         AutoSize        =   -1  'True
         Height          =   2010
         Left            =   180
         Picture         =   "Form1.frx":3AE5
         ScaleHeight     =   1950
         ScaleWidth      =   1995
         TabIndex        =   1
         Top             =   300
         Width           =   2055
      End
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
' Image Fading Example (updated version)
' by PAT or JK
' 3.25.00 (first created 11.6.99)
' http://www.patorjk.com/

' This examples shows you one way on how to fade one picture into
' another picture. On slow computers the fading may take awhile,
' but for the most part it should fade at an ok speed.

' I picked the radiohead and nin cd covers as the pictures to fade
' because they are almost the same size (only a little different).
' (and they're also two of my favorite cds)

' Anyway, when using this code you should only try to fade images
' that are the same size or almost the same size. Note: Larger images
' will take longer to fade.

Option Explicit

Private Declare Function GetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long) As Long
Private Declare Function SetPixel Lib "gdi32" (ByVal hdc As Long, ByVal X As Long, ByVal Y As Long, ByVal crColor As Long) As Long

Public Function GetFadedColor(c1 As Long, c2 As Long, Opacity As Integer) As Long
    ' This sub compares two colors and returns the value of a color that
    ' is a certain distance between the two
    
    Dim i%, red1%, green1%, blue1%, red2%, green2%, blue2%, pat1!, pat2!, pat3!, cx1!, cx2!, cx3!
    
    ' get the red, green, and blue values out of the different
    ' colors
    red1% = (c1 And 255)
    green1% = (c1 \ 256 And 255)
    blue1% = (c1 \ 65536 And 255)
    red2% = (c2 And 255)
    green2% = (c2 \ 256 And 255)
    blue2% = (c2 \ 65536 And 255)
    
    ' get the step of the color changing
    pat1 = (red2% - red1%) / 100
    pat2 = (green2% - green1%) / 100
    pat3 = (blue2% - blue1%) / 100

    ' get the needed color values
    cx1 = red1% + (pat1 * Opacity)
    cx2 = green1% + (pat2 * Opacity)
    cx3 = blue1% + (pat3 * Opacity)
    
    GetFadedColor = RGB(cx1, cx2, cx3)
End Function

Private Sub Form_Load()
    ' make sure all the pictures are the right size
    endpic.Height = startpic.ScaleHeight
    endpic.Width = startpic.ScaleWidth
    HoldNewPic.Height = startpic.ScaleHeight
    HoldNewPic.Width = startpic.ScaleWidth
    PictureHolder.Height = startpic.ScaleHeight
    PictureHolder.Width = startpic.ScaleWidth
    ' set up all the picture boxes so everything works right
    Me.ScaleMode = 3 ' pixel mode
    startpic.ScaleMode = 3
    endpic.ScaleMode = 3
    HoldNewPic.ScaleMode = 3
    PictureHolder.ScaleMode = 3
    ' make sure we'll be able to get the pixels from the pictures
    ' even when they're not shown
    startpic.AutoRedraw = True
    endpic.AutoRedraw = True
    HoldNewPic.AutoRedraw = True
    ' set the pictureholder equal to the start picture
    PictureHolder.Picture = startpic.Picture
End Sub

Private Sub hsrcFadeValue_Change()
    Dim rows As Integer, cols As Integer, Color1 As Long, Color2 As Long
    Dim TheColor As Long
    ' just in case something goes wrong
    On Error Resume Next
    ' loop through all the pixels in the picture boxes
    For cols = 0 To startpic.ScaleWidth - 1
        For rows = 0 To startpic.ScaleHeight - 1
            Color1 = GetPixel(startpic.hdc, rows, cols)
            Color2 = GetPixel(endpic.hdc, rows, cols)
            If Color1 <> Color2 Then
                ' get the color pixel we want
                TheColor = GetFadedColor(Color1, Color2, hsrcFadeValue.Value)
            Else
                ' the two colors are the same so we don't
                ' need to waste time with the fading sub
                TheColor = Color1
            End If
            ' set the pixel in our holding picture box
            Call SetPixel(HoldNewPic.hdc, rows, cols, TheColor)
        Next
    Next
    ' set the created picture in the holding picture box to the
    ' picture box we see on screen
    Set PictureHolder.Picture = HoldNewPic.Image
End Sub
